# TL-bruteforce-solution
# Киндер М. (14.10.2024)
def gen(n):
    if n == 0:
        yield ''
    else:
        for shorter in gen(n - 1):
            yield 'R' + shorter
            yield 'L' + shorter
# ======================================
def stern(s):  
    a, b   = -1, 1
    a1, b1 =  1, 0
    for i in range(len(s)):
        if s[i] == 'L':
            a1 += a
            b1 += b
        if s[i] == 'R':
            a += a1
            b += b1
    a += a1
    b += b1
    return a, b
# ======================================
x,y = map(int, input().split())
for n in range(1, 20):
    s = [*gen(n)]
    for i in range(0, 2**n-1):
        a,b = stern(s[i])
        if (a*y == b*x):
            print(s[i])
            exit()