#include<bits/stdc++.h>

using namespace std;
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")
#pragma GCC optimize "-O3"

const int MAXN = 2e5 + 5;

vector<int> graph[MAXN];

void solve(){
	int n, m, k;
	cin >> n >> m >> k;
	for(int i = 0; i < m; ++i){
		int x, y;
		cin >> x >> y;
		--x, --y;


		graph[x].push_back(y);
		graph[y].push_back(x);
	}


	priority_queue<pair<int, int>> q;
	vector<int> dp(n, 0);
	for(int i = 0; i < k; ++i){
		int x, y;
		cin >> x >> y;
		--x, ++y;
		if(dp[x] > y) continue;

		dp[x] = y;
		q.emplace(y, x);

		while(q.size() > 0){
			auto [val, node] = q.top();
			q.pop();

			if(dp[node] > val) continue;
			for(auto to : graph[node]){
				if(dp[to] < val - 1){
					dp[to] = val - 1;
					q.emplace(val - 1, to);
				}
			}
		}
	}

	vector<int> ans;
	for(int i = 0; i < n; ++i){

		if(dp[i] > 0)
			ans.push_back(i + 1);
	}
	
	cout << ans.size() << '\n';
	for(auto to : ans)
		cout << to << ' ';
}

int main(){
	ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
	solve();
	return 0;
}