#include <bits/stdc++.h>
 
using namespace std;

#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")
#pragma GCC optimize "-O3"

//#define int long long
#define all(x) begin(x),end(x)
// #define double long double
#define pb push_back
 
const double pi = acosl(-1);
 
const int MAXN = 12;
const double INF = 1e18;
 

double dists[MAXN][MAXN];

int n;
int p[MAXN];
double ans = INF;
double tmp = 0;
void gen(int l, int r){
  if(l == r){
    tmp = 0;
    for(int i = 1; i < n; ++i)
      tmp += dists[p[i - 1]][p[i]];
    ans = min(ans, tmp);
    return;
  }else{
    // tmp -= ((l - 1 >= 0 ? dists[p[l - 1]][p[l]]:0) + (l + 1 < n ? dists[p[l]][p[l + 1]]:0));
    for(int i = l; i <= r; ++i){
      // tmp -= ((i - 1 >= 0 ? dists[p[i - 1]][p[i]]:0) + (i + 1 < n ? dists[p[i]][p[i + 1]]:0));

      swap(p[l], p[i]);

      // tmp += ((l - 1 >= 0 ? dists[p[l - 1]][p[l]]:0) + (l + 1 < n ? dists[p[l]][p[l + 1]]:0));
      // tmp += ((i - 1 >= 0 ? dists[p[i - 1]][p[i]]:0) + (i + 1 < n ? dists[p[i]][p[i + 1]]:0));
      gen(l+1, r);
      // tmp -= ((l - 1 >= 0 ? dists[p[l - 1]][p[l]]:0) + (l + 1 < n ? dists[p[l]][p[l + 1]]:0));
      // tmp -= ((i - 1 >= 0 ? dists[p[i - 1]][p[i]]:0) + (i + 1 < n ? dists[p[i]][p[i + 1]]:0));

      swap(p[l], p[i]);
      // tmp += ((i - 1 >= 0 ? dists[p[i - 1]][p[i]]:0) + (i + 1 < n ? dists[p[i]][p[i + 1]]:0));
    }
    // tmp += ((l - 1 >= 0 ? dists[p[l - 1]][p[l]]:0) + (l + 1 < n ? dists[p[l]][p[l + 1]]:0));
  }
}
 
 
signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cin >> n;
  vector<pair<int, int>> pts(n);
  for (auto &el : pts) 
    cin >> el.first >> el.second;
  
  for(int i = 0; i < MAXN; ++i)
    p[i] = i;

  vector<double> angs;
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      double ang = atan2l(pts[i].second - pts[j].second, pts[i].first - pts[j].first);
      angs.push_back(-ang);
      angs.push_back(ang);
    }
  }

  auto rotate = [](double x, double y, double cs, double sn) -> pair<double, double> {
    return {(x * cs - y * sn), (y * cs + x * sn)};
  };

  double cs;
  double sn;
  for (auto ang : angs) {
    cs = cosl(ang);
    sn = sinl(ang);
    int n = pts.size();
    for (int i = 0; i < n; ++i) {
      p[i] = i;
      for (int j = i + 1; j < n; ++j) {
        auto pt1 = rotate(pts[i].first, pts[i].second, cs, sn);
        auto pt2 = rotate(pts[j].first, pts[j].second, cs, sn);
        double dist = abs(pt1.first - pt2.first) + abs(pt1.second - pt2.second);
        dists[i][j] = dist;
        dists[j][i] = dist;
      }
    }
    gen(0, n-1);
  }
  cout << fixed << setprecision(20) << ans << '\n';
}
