// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")
#pragma GCC optimize "-O3"


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define P pair
typedef P<ll, ll> Pii;
typedef P<ll, ll> Pll;
typedef P<string, string> Pss;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


#define endl '\n'

// #define len(a) (ll)a.size()

#define yes "YES\n"
#define no "NO\n"
#define imp "impossible"

#define pb push_back


bool bit(ll mask, ll k){
    return ((mask >> k)&1);
}

ll get_rand() {
   return (rand() << 16) ^ rand();
}

template<typename T>
struct pnt
{
    T x, y;
    pnt(){}
    pnt(T _x, T _y): x(_x), y(_y){}
    // pnt(pnt<T> a){
    //     x = a.x;
    //     y = a.y;
    // }
    // T lenSq(){
    //     return x*x + y*y;
    // }
    
    ld len(){
        return abs(x) + abs(y);
    }
};
template<typename T>
istream& operator >>(std::istream& in, pnt<T>& a){
    in >> a.x >> a.y;
    return in;
}


template<typename T>
T angle(pnt<T> a){
    return atan2(a.y, a.x);
}

template<typename T>
pnt<T> operator-(pnt<T> a, pnt<T> b){
    return pnt<T>(a.x - b.x, a.y - b.y);
}

template<typename T>
pnt<T> operator*(pnt<T> a, T b){
    return pnt<T>(a.x * b, a.y * b);
}

template<typename T>
pnt<T> rot(pnt<T> p, ld a){
    return pnt<T>(
        cos(a) * p.x - sin(a) * p.y,
        sin(a) * p.x + cos(a) * p.y
    );
}

void solve() {
    int n;
    cin >> n;

    vector<pnt<ld>> a(n);
    for(int i = 0; i < n; ++i)
        cin >> a[i];

    ld ans = 1e12;
    for(int itA = 0; itA < n; ++itA){
        for(int itB = 0; itB < n; ++itB){
            if(itA == itB) continue;

            pnt<ld> seg =  (a[itA] - a[itB]);
            ld alpha = angle(seg);

            for(int it = 0; it < 2; ++it){
                vector<pnt<ld>> p = a;
                for(int i = 0; i < n; ++i){
                    p[i] = rot(p[i], alpha);
                }

                vector<vector<ld>> dp((1<<n), vector<ld>(n, 1e12));
                for(int i = 0; i < n; ++i){
                    dp[(1<<i)][i] = 0;
                }
                for(int mask = 0; mask < (1<<n); ++mask){
                    for(int i = 0; i < n; ++i){
                        for(int j = 0; j < n; ++j){
                            // dp[mask]
                            if(bit(mask, i) && !bit(mask, j)){
                                dp[mask|(1<<j)][j] = min(
                                    dp[mask|(1<<j)][j], 
                                    dp[mask][i] + (p[j] - p[i]).len()
                                );
                            }
                        }
                    }
                }

                for(int i = 0; i < n; ++i){
                    ans = min(ans, dp[(1<<n) - 1][i]);
                }
                alpha = alpha * (-1);
            }
        }
    }
    cout << fixed << setprecision(12) << ans;
    return;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    // freopen("input.in", "r", stdin);
    // freopen("output.out", "w", stdout);

    
    // ll start = chrono::steady_clock::now().time_since_epoch().count();
    // solve();
    // ll end = chrono::steady_clock::now().time_since_epoch().count();
    // cerr << endl << (end - start) / 1000000 << "ms" << endl;


    ll t = 1;
    // cin >> t;
    while(t--){
        solve();
    }
}